﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;

namespace _20131004_TicketThinkgeo
{
    /// <summary>
    /// Logique d'interaction pour MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void wpfMap1_Loaded(object sender, RoutedEventArgs e)
        {
            wpfMap1.MapUnit = GeographyUnit.Meter;
            InMemoryFeatureLayer inMem = new InMemoryFeatureLayer();
            ZoomLevelSet zleMemSlc = new ZoomLevelSet();
            zleMemSlc.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(125, 94, 139, 229), GeoColor.SimpleColors.LightOrange, 5);               
            zleMemSlc.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            inMem.ZoomLevelSet = zleMemSlc;

            LayerOverlay ovLyr = new LayerOverlay();
            ovLyr.Layers.Add("InMem", inMem);
            wpfMap1.Overlays.Add(ovLyr);
            wpfMap1.Refresh();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            wpfMap1.TrackOverlay.TrackMode = TrackMode.Polygon;
            wpfMap1.TrackOverlay.TrackEnded += new EventHandler<TrackEndedTrackInteractiveOverlayEventArgs>(trackOverlay_TrackEnded);
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            foreach (Feature feature in ((InMemoryFeatureLayer)wpfMap1.FindFeatureLayer("InMem")).InternalFeatures)
            {
                wpfMap1.EditOverlay.EditShapesLayer.InternalFeatures.Add(feature.Id, feature);
            }
            wpfMap1.EditOverlay.CalculateAllControlPoints();
            wpfMap1.Refresh();

        }

        private void trackOverlay_TrackEnded(object sender, TrackEndedTrackInteractiveOverlayEventArgs e)
        {
            InMemoryFeatureLayer inMem =  (InMemoryFeatureLayer)wpfMap1.FindFeatureLayer("InMem");
            inMem.InternalFeatures.Add(e.TrackShape.GetFeature());
            ((TrackInteractiveOverlay)sender).TrackShapeLayer.InternalFeatures.Clear();
            wpfMap1.TrackOverlay.TrackMode = TrackMode.None;
            wpfMap1.TrackOverlay.TrackEnded -= new EventHandler<TrackEndedTrackInteractiveOverlayEventArgs>(trackOverlay_TrackEnded);
            wpfMap1.Refresh();
        }
    }
}
